Index: /vtcross/trunk/configure.ac
===================================================================
--- /vtcross/trunk/configure.ac	(revision 355)
+++ /vtcross/trunk/configure.ac	(revision 411)
@@ -1,2 +1,17 @@
+dnl Copyright 2009 Virginia Polytechnic Institute and State University  
+dnl 
+dnl Licensed under the Apache License, Version 2.0 (the "License"); 
+dnl you may not use this file except in compliance with the License. 
+dnl You may obtain a copy of the License at 
+dnl 
+dnl http://www.apache.org/licenses/LICENSE-2.0 
+dnl
+dnl Unless required by applicable law or agreed to in writing, software 
+dnl distributed under the License is distributed on an "AS IS" BASIS, 
+dnl WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+dnl See the License for the specific language governing permissions and 
+dnl limitations under the License. 
+
+
 AC_INIT([cross], [0.1.1])
 AM_INIT_AUTOMAKE([cross], [0.1.1])
Index: /vtcross/trunk/Makefile.common
===================================================================
--- /vtcross/trunk/Makefile.common	(revision 323)
+++ /vtcross/trunk/Makefile.common	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 CROSS_LA = ${abs_top_builddir}/src/libvtcross/libvtcross.la
 CROSS_SOCKETCOMM_LA = ${abs_top_builddir}/src/lib/socketcomm/libsocketcomm.la
Index: /vtcross/trunk/doc/Makefile.am
===================================================================
--- /vtcross/trunk/doc/Makefile.am	(revision 161)
+++ /vtcross/trunk/doc/Makefile.am	(revision 411)
@@ -0,0 +1,13 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
Index: /vtcross/trunk/src/cognitive_engines/Makefile.am
===================================================================
--- /vtcross/trunk/src/cognitive_engines/Makefile.am	(revision 348)
+++ /vtcross/trunk/src/cognitive_engines/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/cognitive_engines/CBR_CE/cbr.c
===================================================================
--- /vtcross/trunk/src/cognitive_engines/CBR_CE/cbr.c	(revision 347)
+++ /vtcross/trunk/src/cognitive_engines/CBR_CE/cbr.c	(revision 411)
@@ -1,5 +1,17 @@
-//
-// Case-based reasoner
-//
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 #include <stdlib.h>
Index: /vtcross/trunk/src/cognitive_engines/CBR_CE/Makefile.am
===================================================================
--- /vtcross/trunk/src/cognitive_engines/CBR_CE/Makefile.am	(revision 347)
+++ /vtcross/trunk/src/cognitive_engines/CBR_CE/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/cognitive_engines/CBR_CE/cbr_demo.cpp
===================================================================
--- /vtcross/trunk/src/cognitive_engines/CBR_CE/cbr_demo.cpp	(revision 347)
+++ /vtcross/trunk/src/cognitive_engines/CBR_CE/cbr_demo.cpp	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * TODO LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* TODO DESCRIPTION OF FILE.
Index: /vtcross/trunk/src/cognitive_engines/CBR_CE/CognitiveEngine.cpp
===================================================================
--- /vtcross/trunk/src/cognitive_engines/CBR_CE/CognitiveEngine.cpp	(revision 347)
+++ /vtcross/trunk/src/cognitive_engines/CBR_CE/CognitiveEngine.cpp	(revision 411)
@@ -1,11 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
-
-/* DESCRIPTION OF FILE.
- */
-
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 #include <cstdlib>
Index: /cross/trunk/src/cognitive_engines/CBR_CE/cbr_demo.c
===================================================================
--- /vtcross/trunk/src/cognitive_engines/CBR_CE/cbr_demo.c	(revision 347)
+++ 	(revision )
@@ -1,593 +1,0 @@
-#include <stdio.h>
-#include <sys/types.h>
-#include <sys/socket.h>
-#include <netinet/in.h>
-#include <netdb.h>
-//#include <iostream>
-#include <stdlib.h>
-#include <string.h>
-#include <sqlite3.h>
-#include <sqlite3ext.h>
-
-#include "vtcross/cbr.h"
-#include "vtcross/common.h"
-
-//using namespace std;
-
-struct CE_Info {
-    int numUtilities;
-    int numParameters;
-    int numObservables;
-};
-
-struct Utility {
-    char name[50];
-    char units[50];
-    char goal[50];
-   /* string name;
-    string units;
-    string goal;*/
-    float target;
-    float value;
-};
-
-struct Affect {
-    struct Utility u; 
-    //string relation;
-    char relation[50];
-};      
-
-struct Parameter {
-    /*string name;
-    string units;*/
-    char name[50];
-    char units[50];
-    float min;
-    int numAffects; 
-    struct Affect affection_list[10];
-    float max;
-    float step;
-    float value;
-};      
-        
-struct Observable {
-    //string name;
-    char name[50];
-    struct Affect affection_list[10];
-    int numAffects;
-    float value;
-};
-
-// error handling
-void error(char *msg)
-{
-    perror(msg);
-    exit(0);
-}
-
-void ReadMessage(int socket,char * buffer) {
-    int i,n;
-
-    n = recv(socket,buffer,256,MSG_PEEK);
-    for(i=0;i<256;i++){
-	    if(strcmp(&buffer[i],"\0") == 0) break;
-    }
-    n = recv(socket,buffer,i+1,0);
-    if (n < 0) 
-         error("ERROR reading from socket");
-    //printf("ReadMessage:%s %d\n",buffer,n);
-}
-
-
-int GetUtility(int sockfd, struct Utility uList[], struct CE_Info *ce_info)
-{
-    char buffer[256];
-    int i;
-
-    // read unitilities
-    // numUtilities
-    bzero(buffer,256);
-    ReadMessage(sockfd,buffer);
-    ce_info->numUtilities = atoi(buffer);
-    //printf("number of utilities: %d\n", ce_info->numUtilities);
-        
-    for (i = 0; i < ce_info->numUtilities; i++){
-        bzero(buffer,256);
-	    ReadMessage(sockfd,buffer);
-	    //printf("Name: %s\n", buffer);
-        strcpy(uList[i].name, buffer);
-                 
-        bzero(buffer,256);
-	    ReadMessage(sockfd,buffer);
-	    //printf("Units: %s\n", buffer);
-        strcpy(uList[i].units, buffer);
-
-        bzero(buffer,256);
-	    ReadMessage(sockfd,buffer);
-        //printf("Goal: %s\n", buffer);
-        strcpy(uList[i].goal, buffer);
-        
-	    bzero(buffer,256);
-	    ReadMessage(sockfd,buffer);
-        //printf("Target: %s\n", buffer);
-        uList[i].target = atof(buffer);
-    }
-    return 1;
-}
-
-
-int GetParameter(int sockfd, struct Parameter pList[], struct CE_Info *ce_info)
-{
-    char buffer[256];
-    int i, j;
-
-    // numParameters
-    bzero(buffer,256);
-    ReadMessage(sockfd,buffer);
-    ce_info->numParameters = atoi(buffer);
-    //printf("number of parameters: %d\n", ce_info->numParameters);
-        
-    for (i = 0; i < ce_info->numParameters; i++){
-        bzero(buffer,256);
-	    ReadMessage(sockfd,buffer);
-	    //printf("Name: %s\n", buffer);
-        strcpy(pList[i].name, buffer);
-                 
-        bzero(buffer,256);
-	    ReadMessage(sockfd,buffer);
-	    //printf("Units: %s\n", buffer);
-        strcpy(pList[i].units, buffer);
-
-        bzero(buffer,256);
-	    ReadMessage(sockfd,buffer);
-        //printf("Min: %s\n", buffer);
-        pList[i].min = atof(buffer);
-        
-        bzero(buffer,256);
-	    ReadMessage(sockfd,buffer);
-        //printf("Max: %s\n", buffer);
-        pList[i].max = atof(buffer);
-        
-	    bzero(buffer,256);
-	    ReadMessage(sockfd,buffer);
-        //printf("Step: %s\n", buffer);
-        pList[i].step = atof(buffer);
-    
-        // numAffects
-        bzero(buffer,256);
-        ReadMessage(sockfd,buffer);
-        pList[i].numAffects = atoi(buffer);
-        //printf("number of affects: %d\n", pList[i].numAffects);
-        
-        for (j = 0; j < pList[i].numAffects; j++){
-            bzero(buffer,256);
-	        ReadMessage(sockfd,buffer);
-	        //printf("Utility name: %s\n", buffer);
-            strcpy(pList[i].affection_list[j].u.name, buffer);
-                 
-            bzero(buffer,256);
-	        ReadMessage(sockfd,buffer);
-	        //printf("Relation: %s\n", buffer);
-            strcpy(pList[i].affection_list[j].relation, buffer);
-        }
-    }
-    return 1;
-}
-
-
-int GetObservable(int sockfd, struct Observable oList[], struct CE_Info *ce_info)
-{
-    char buffer[256];
-    int i,j;
-
-    // numParameters
-    bzero(buffer,256);
-    ReadMessage(sockfd,buffer);
-    ce_info->numObservables = atoi(buffer);
-    //printf("number of observables: %d\n", ce_info->numObservables);
-        
-    for (i = 0; i < ce_info->numObservables; i++){
-        bzero(buffer,256);
-	    ReadMessage(sockfd,buffer);
-	    //printf("Name: %s\n", buffer);
-        strcpy(oList[i].name, buffer);
-                 
-        // numAffects
-        bzero(buffer,256);
-        ReadMessage(sockfd,buffer);
-        oList[i].numAffects = atoi(buffer);
-        //printf("number of affects: %d\n", oList[i].numAffects);
-        
-        for (j = 0; j < oList[i].numAffects; j++){
-            bzero(buffer,256);
-	        ReadMessage(sockfd,buffer);
-	        //printf("Utility name: %s\n", buffer);
-            strcpy(oList[i].affection_list[j].u.name, buffer);
-                 
-            bzero(buffer,256);
-	        ReadMessage(sockfd,buffer);
-	        //printf("Relation: %s\n", buffer);
-            strcpy(oList[i].affection_list[j].relation, buffer);
-        }
-    }
-    return 1;
-}
-
-
-// setup client socket connection
-int ClientSocket(int argc, char** argv)
-{
-    int sockfd;
-    int portno;
-    struct sockaddr_in serv_addr;
-    struct hostent *server;
-    
-    // setup client socket connection
-    if (argc < 3) {
-       fprintf(stderr,"usage: %s hostname port\n", argv[0]);
-       exit(0);
-    }
-    // server name
-    server = gethostbyname(argv[1]);
-    if (server == NULL) {
-        fprintf(stderr,"ERROR, no such host\n");
-        exit(0);
-    }
-    // port no.
-    portno = atoi(argv[2]);
-    // socket file descriptor
-    sockfd = socket(AF_INET, SOCK_STREAM, 0);
-    if (sockfd < 0) 
-        error("ERROR opening socket");
-    // initiate struct socketaddr_in
-    bzero((char *) &serv_addr, sizeof(serv_addr));
-    serv_addr.sin_family = AF_INET;
-    serv_addr.sin_port = htons(portno);
-    bcopy((char *)server->h_addr, 
-         (char *)&serv_addr.sin_addr.s_addr,
-         server->h_length);
-    // cast sockaddr_in to sockaddr
-    if (connect(sockfd,(struct sockaddr *)&serv_addr,sizeof(serv_addr)) < 0) 
-        error("ERROR connecting");
-
-    return sockfd;
-}
-
-    
-int SendMessage(int socketfd, char *message) 
-{
-    int n;
-     
-    strcat(message, "\0000");
-    // Write message back to client
-    //n = write(socketfd,message,(strlen(message)+1));
-    n = send(socketfd,message,(strlen(message)+1),0);
-    if (n<0)
-        error("Error sending to server\n");
-    else if(n == 0)
-        printf("Server closed the socket.\n");
-    
-    return n;
-}
-
-
-int GetXMLFromServer(int sockfd, struct Utility uList[], struct Parameter pList[], 
-        struct Observable oList[], struct CE_Info *ce_info)
-{
-    // get utilities
-    GetUtility(sockfd, uList, ce_info);
-    
-    // get parameters
-    GetParameter(sockfd, pList, ce_info);
-
-    // read obervables
-    GetObservable(sockfd, oList, ce_info);
-
-    // send ack back to server
-    char buffer[256];
-    strcpy(buffer, "xml received");
-    SendMessage(sockfd, buffer);
-    //printf("xml reception done\n");
-    
-    return 1;
-}
-
-
-int GetExperienceSize(int sockfd, int *num_rows, int *num_cols)
-{
-    char buffer[256];
-    
-    // number of rows
-    bzero(buffer,256);
-    ReadMessage(sockfd,buffer);
-    *num_rows = atoi(buffer);
-    // number of columns
-    bzero(buffer,256);
-    ReadMessage(sockfd,buffer);
-    *num_cols = atoi(buffer);
-    return 1;
-}
-
-int GetRequest(int sockfd)
-{
-    char buffer[256];
-
-	bzero(buffer,256);
-	ReadMessage(sockfd,buffer);
-
-    return 1;
-}
-
-int GetExperience(int sockfd, int num_rows, int num_cols, 
-        //float **past_exp)
-        float past_exp[num_rows][num_cols])
-{
-    char buffer[256];
-    int i, j;
-
-    // read experience
-    for (i = 0; i < num_rows; i++){
-        for (j = 0; j < num_cols; j++){
-	    bzero(buffer,256);
-	    ReadMessage(sockfd,buffer);
-    //    printf("experience: %s\n", buffer);
-        past_exp[i][j] = atof(buffer);
-        }
-    }
-
-    return 1;
-}
-
-
-void print_current_config(struct Utility uList[], 
-        struct Parameter pList[], 
-        struct Observable oList[], 
-        struct CE_Info * ce_info) 
-{    
-    int i = 0;
-    int j = 0;
-
-    // utilities
-    for(i = 0; i < ce_info->numUtilities ; i++) {
-        printf("Utility: %s\n", uList[i].name);
-        printf("    Units: %s\n", uList[i].units);
-        printf("    Goal: %s\n", uList[i].goal);
-        printf("    Target: %f\n", uList[i].target);
-        /*cout << "Utility:  " << uList[i].name << endl;
-        cout << "     Units:  " << uList[i].units << endl;
-        cout << "     Goal:   " << uList[i].goal << endl;
-        cout << "     Target: " << uList[i].target << endl;*/
-    }
-                       
-    // parameters                        
-    for(i = 0; i < ce_info->numParameters; i++) {
-        printf("Paramter: %s\n", pList[i].name);
-        printf("    Units: %s\n", pList[i].units);
-        printf("    Min: %f\n", pList[i].min);
-        printf("    Max: %f\n", pList[i].max);
-        printf("    Step: %f\n", pList[i].step);
-        /*cout << "Parameter:  " << pList[i].name << endl;
-        cout << "       Units:   " << pList[i].units << endl;
-        cout << "       Min:     " << pList[i].min << endl;
-        cout << "       Max:     " << pList[i].max << endl;
-        cout << "       Step:    " << pList[i].step << endl;*/
-        for(j = 0; j < pList[i].numAffects; j++) {
-            printf("        Affect: %s -> %s\n", pList[i].affection_list[j].u.name, pList[i].affection_list[j].relation);
-            //cout << "       Affect: " << pList[i].affection_list[j].u.name << " -> " << pList[i].affection_list[j].relation << endl;
-        }
-    }
-
-    // observables
-    for(i = 0; i < ce_info->numObservables; i++) {
-        printf("Observable: %s\n", oList[i].name);
-        //cout << "Observable:  " << oList[i].name << endl;
-        for(j = 0; j < oList[i].numAffects; j++) {
-            printf("        Affect: %s -> %s\n", oList[i].affection_list[j].u.name, oList[i].affection_list[j].relation);
-            //cout << "       Affect: " << oList[i].affection_list[j].u.name << " -> " << oList[i].affection_list[j].relation << endl;
-        }
-    }
-}
-
-int RunCBREngine(struct Utility uList[], struct Parameter pList[],
-        struct Observable oList[], struct CE_Info *ce_info, 
-        //int num_cols, int num_rows, float ** past_exp)
-        int num_cols, int num_rows, float past_exp[num_rows][num_cols])
-{
-    
-    int i, j;
-
-    // get column names
-    /*char *cols[50] = {"throughput", "spectral_efficiency", 
-    "log10_ber", "mod_scheme", "tx_power", "SNR", "utility"};*/
-    //char cols[num_cols][50];
-   
-
-    char **cols;
-    cols = (char **)malloc(sizeof(char)*num_cols);
-    j = 0;
-    for (i = 0; i < ce_info->numUtilities; i++){
-        cols[j] = malloc(strlen(uList[i].name)+1);
-        cols[j] = uList[i].name;
-    //    strcpy(cols[j], uList[i].name);
-        j++;
-    }
-    for (i = 0; i < ce_info->numParameters; i++){
-        cols[j] = malloc(strlen(pList[i].name)+1);
-        cols[j] = pList[i].name;
-    //    strcpy(cols[j], pList[i].name);
-        j++;
-    }
-    for (i = 0; i < ce_info->numObservables; i++){
-        cols[j] = malloc(strlen(oList[i].name)+1);
-        cols[j] = oList[i].name;
-    //    strcpy(cols[j], oList[i].name);
-        j++;
-    }
-    cols[j] = malloc(strlen("utility")+1);
-    cols[j] = "utility";
-    
-    //printf("column names:");
-    //for (i = 0; i<num_cols; i++){
-    //    printf(" %s",cols[i]);
-    //}
-    //printf("\n");
-
-    int rc;
-
-    // create cbr database/table
-    //printf("create cbr database\n");
-    char filename[] = {"ex1"}, tablename[] = {"data"};
-    cbr mycbr = cbr_create(filename, tablename, cols, num_cols);
-    //cbr mycbr = cbr_create("ex1", "data", cols, num_cols);
-
-    // add row here
-    float vals[num_cols];
-    /*// sample table entry
-    vals[0] = 1e3f;    // throughput
-    vals[1] = 1;        // spectral_efficiency
-    vals[2] = -3.50;    // log10_ber
-    vals[3] = 1;        // mod_scheme
-    vals[4] = -3.5f;    // tx_power
-    vals[5] = 10.0f;   // SNR
-    vals[6] = 0.762;    // utility*/
-    for (i = 0; i < num_rows; i++){
-        for (j = 0; j < num_cols; j++){
-            vals[j] = past_exp[i][j];
-        }
-        rc = cbr_add_row(mycbr, cols, vals, num_cols);
-    }
-    
-    // print
-    printf("cbr table\n");
-    cbr_print(mycbr);
-    
-    // simple search: find entry where...
-    //   log10_ber < 1e-2 and SNR > 5
-    //char * search_names[] = {"log10_ber", "SNR"};
-    char ** search_names;
-    search_names
-        = (char **)malloc(sizeof(char)*(ce_info->numUtilities));
-    for (i = 0; i < ce_info->numUtilities; i++){
-        search_names[i] 
-            = malloc(sizeof(char)*(strlen(uList[i].name)+1));
-        search_names[i] = uList[i].name;
-    }
-    int search_ops[] = {GT, GT, LT};
-    //float search_vals[] = {1e-2f, 5.f};
-    float *search_vals;
-    search_vals = malloc(sizeof(float)*(ce_info->numUtilities));
-    for (i = 0; i < ce_info->numUtilities; i++){
-        search_vals[i] = uList[i].target;
-    }
-    float retvals[num_cols];
-    rc = cbr_search(mycbr, search_names, search_ops, 
-            search_vals, ce_info->numUtilities, retvals);
-
-    j = 0;
-    for (i = 0; i < ce_info->numUtilities; i++){
-        uList[i].value = retvals[j];
-        j++;
-    }
-    for (i = 0; i < ce_info->numParameters; i++){
-        pList[i].value = retvals[j];
-        j++;
-    }
-    for (i = 0; i < ce_info->numObservables; i++){
-        oList[i].value = retvals[j];
-        j++;
-    }
-
-    // clean up database
-    //printf("clean cbr database\n");
-    cbr_free(mycbr);
-    
-    return 1;
-}
-
-
-int SendCEResults(int sockfd, struct Utility uList[], struct Parameter pList[], 
-        struct Observable oList[], struct CE_Info *ce_info)
-{
-    // send results back to server
-    char var[50];
-    int i;
- 
-    /*// utility
-    for (i = 0; i < ce_info->numUtilities; i++){
-        sprintf(var, "%f", uList[i].value);
-        SendMessage(sockfd, var);
-    }*/
-    
-    // parameter
-    for (i = 0; i < ce_info->numParameters; i++){
-        sprintf(var, "%f", pList[i].value);
-        SendMessage(sockfd, var);
-    }
-    
-    /*// observable
-    for (i = 0; i < ce_info->numObservables; i++){
-        sprintf(var, "%f", oList[i].value);
-        SendMessage(sockfd, var);
-    }*/
-
-    return 1;
-}
-
-int RegisterCE(int sockfd, struct Utility uList[], struct Parameter pList[], 
-        struct Observable oList[], struct CE_Info *ce_info)
-{
-    // Send register message to cognitive radio
-    SendMessage(sockfd, "register_engine_cognitive");
-    return 1;
-}
-
-// main client socket
-int main(int argc, char *argv[])
-{
-    struct Utility uList[10];
-    struct Parameter pList[10];
-    struct Observable oList[10];
-    struct CE_Info ce_info;
-    char buffer[256];
-
-    // setup client socket connection
-    int sockfd;
-    sockfd = ClientSocket(argc, argv);
-
-    RegisterCE(sockfd,uList,pList,oList,&ce_info);
-    // get xml info from server
-    GetXMLFromServer(sockfd, uList, pList, oList, &ce_info);
-    printf("Received Radio Operation Profile from Server Successfully.\n\n");
-    //print_current_config(uList, pList, oList, &ce_info); 
-    
-    // get experience size from server
-    int num_rows, num_cols;
-    GetExperienceSize(sockfd, &num_rows, &num_cols);
-
-    // get experience
-    int i, j;
-    float past_exp[num_rows][num_cols];
-    GetExperience(sockfd, num_rows, num_cols, past_exp);
-    printf("Received Previous Radio Experience from Server Successfully.\n\n");
-    // cbr operation
-    //unsigned int num_cols;
-    // get number of columns
-    num_cols = ce_info.numUtilities + ce_info.numParameters;
-    num_cols = num_cols + ce_info.numObservables;
-    num_cols = num_cols + 1;    // overall utility
-    //while(1) {
-        
-        // Wait until request is received from server to perform optimization 
-        //printf("Waiting for Request for optimization from Server\n\n");
-        //GetRequest(sockfd);
-        //printf("Received optimization request from server\n\n");
-        RunCBREngine(uList, pList, oList, &ce_info, num_cols, num_rows, past_exp);    
-   
-        printf("Sending optimization results to server.\n\n");
-        // send results back to server
-        SendCEResults(sockfd, uList, pList, oList, &ce_info);
-        
-    //}
-    
-    return 0;
-}
Index: /vtcross/trunk/src/cognitive_engines/DSA_CE/DSA_CognitiveEngine.cpp
===================================================================
--- /vtcross/trunk/src/cognitive_engines/DSA_CE/DSA_CognitiveEngine.cpp	(revision 392)
+++ /vtcross/trunk/src/cognitive_engines/DSA_CE/DSA_CognitiveEngine.cpp	(revision 411)
@@ -1,11 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
-
-/* DESCRIPTION OF FILE.
- */
-
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 #include <cstdlib>
Index: /vtcross/trunk/src/cognitive_engines/DSA_CE/cbr.c
===================================================================
--- /vtcross/trunk/src/cognitive_engines/DSA_CE/cbr.c	(revision 391)
+++ /vtcross/trunk/src/cognitive_engines/DSA_CE/cbr.c	(revision 411)
@@ -1,2 +1,19 @@
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
+
+
 //
 // Case-based reasoner
Index: /vtcross/trunk/src/cognitive_engines/DSA_CE/Makefile.am
===================================================================
--- /vtcross/trunk/src/cognitive_engines/DSA_CE/Makefile.am	(revision 376)
+++ /vtcross/trunk/src/cognitive_engines/DSA_CE/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/cognitive_engines/DSA_CE/DSA_Demo.cpp
===================================================================
--- /vtcross/trunk/src/cognitive_engines/DSA_CE/DSA_Demo.cpp	(revision 375)
+++ /vtcross/trunk/src/cognitive_engines/DSA_CE/DSA_Demo.cpp	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * TODO LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* TODO DESCRIPTION OF FILE.
Index: /vtcross/trunk/src/cognitive_engines/DSA_CE/examples/libcross_demo.py
===================================================================
--- /vtcross/trunk/src/cognitive_engines/DSA_CE/examples/libcross_demo.py	(revision 389)
+++ /vtcross/trunk/src/cognitive_engines/DSA_CE/examples/libcross_demo.py	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 # Simple Python demonstration script for using
 # the CROSS system.
Index: /vtcross/trunk/src/include/vtcross/error.h
===================================================================
--- /vtcross/trunk/src/include/vtcross/error.h	(revision 161)
+++ /vtcross/trunk/src/include/vtcross/error.h	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* DESCRIPTION OF FILE.
Index: /vtcross/trunk/src/include/vtcross/libvtcross.h
===================================================================
--- /vtcross/trunk/src/include/vtcross/libvtcross.h	(revision 284)
+++ /vtcross/trunk/src/include/vtcross/libvtcross.h	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* VTCROSS Cognitive Radio API
Index: /vtcross/trunk/src/include/vtcross/Makefile.am
===================================================================
--- /vtcross/trunk/src/include/vtcross/Makefile.am	(revision 323)
+++ /vtcross/trunk/src/include/vtcross/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/include/vtcross/socketcomm.h
===================================================================
--- /vtcross/trunk/src/include/vtcross/socketcomm.h	(revision 389)
+++ /vtcross/trunk/src/include/vtcross/socketcomm.h	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * TODO LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* TODO DESCRIPTION OF FILE.
Index: /vtcross/trunk/src/include/vtcross/components.h
===================================================================
--- /vtcross/trunk/src/include/vtcross/components.h	(revision 389)
+++ /vtcross/trunk/src/include/vtcross/components.h	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* This header exports the declarations for all VT-CROSS radio components.  It
Index: /vtcross/trunk/src/include/vtcross/containers.h
===================================================================
--- /vtcross/trunk/src/include/vtcross/containers.h	(revision 386)
+++ /vtcross/trunk/src/include/vtcross/containers.h	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* This header contains commonly used data container structs in VT-CROSS
Index: /vtcross/trunk/src/include/vtcross/cbr.h
===================================================================
--- /vtcross/trunk/src/include/vtcross/cbr.h	(revision 170)
+++ /vtcross/trunk/src/include/vtcross/cbr.h	(revision 411)
@@ -1,2 +1,18 @@
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
+
 //
 // Case-based reasoner
Index: /vtcross/trunk/src/include/vtcross/debug.h
===================================================================
--- /vtcross/trunk/src/include/vtcross/debug.h	(revision 161)
+++ /vtcross/trunk/src/include/vtcross/debug.h	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* DESCRIPTION OF FILE.
Index: /vtcross/trunk/src/include/vtcross/common.h
===================================================================
--- /vtcross/trunk/src/include/vtcross/common.h	(revision 161)
+++ /vtcross/trunk/src/include/vtcross/common.h	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* This file is included in every source file of the VTCROSS system.  It
Index: /vtcross/trunk/src/include/tinyxml/Makefile.am
===================================================================
--- /vtcross/trunk/src/include/tinyxml/Makefile.am	(revision 323)
+++ /vtcross/trunk/src/include/tinyxml/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/include/Makefile.am
===================================================================
--- /vtcross/trunk/src/include/Makefile.am	(revision 323)
+++ /vtcross/trunk/src/include/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/lib/socketcomm/socketcomm.cpp
===================================================================
--- /vtcross/trunk/src/lib/socketcomm/socketcomm.cpp	(revision 389)
+++ /vtcross/trunk/src/lib/socketcomm/socketcomm.cpp	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * TODO LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* TODO DESCRIPTION OF FILE.
Index: /vtcross/trunk/src/lib/socketcomm/Makefile.am
===================================================================
--- /vtcross/trunk/src/lib/socketcomm/Makefile.am	(revision 323)
+++ /vtcross/trunk/src/lib/socketcomm/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/lib/tinyxml/Makefile.am
===================================================================
--- /vtcross/trunk/src/lib/tinyxml/Makefile.am	(revision 323)
+++ /vtcross/trunk/src/lib/tinyxml/Makefile.am	(revision 411)
@@ -1,2 +1,17 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/lib/Makefile.am
===================================================================
--- /vtcross/trunk/src/lib/Makefile.am	(revision 323)
+++ /vtcross/trunk/src/lib/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/policy_engines/policy_demo.cpp
===================================================================
--- /vtcross/trunk/src/policy_engines/policy_demo.cpp	(revision 187)
+++ /vtcross/trunk/src/policy_engines/policy_demo.cpp	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * TODO LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* TODO DESCRIPTION OF FILE.
Index: /vtcross/trunk/src/policy_engines/PolicyEngine.cpp
===================================================================
--- /vtcross/trunk/src/policy_engines/PolicyEngine.cpp	(revision 205)
+++ /vtcross/trunk/src/policy_engines/PolicyEngine.cpp	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* DESCRIPTION OF FILE.
Index: /vtcross/trunk/src/policy_engines/Makefile.am
===================================================================
--- /vtcross/trunk/src/policy_engines/Makefile.am	(revision 323)
+++ /vtcross/trunk/src/policy_engines/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/shell/CognitiveRadioShell.cpp
===================================================================
--- /vtcross/trunk/src/shell/CognitiveRadioShell.cpp	(revision 389)
+++ /vtcross/trunk/src/shell/CognitiveRadioShell.cpp	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* DESCRIPTION OF FILE.
Index: /vtcross/trunk/src/shell/Makefile.am
===================================================================
--- /vtcross/trunk/src/shell/Makefile.am	(revision 323)
+++ /vtcross/trunk/src/shell/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/shell/shell_demo.cpp
===================================================================
--- /vtcross/trunk/src/shell/shell_demo.cpp	(revision 324)
+++ /vtcross/trunk/src/shell/shell_demo.cpp	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * TODO LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* TODO DESCRIPTION OF FILE.
Index: /vtcross/trunk/src/service_management_layer/sml_demo.cpp
===================================================================
--- /vtcross/trunk/src/service_management_layer/sml_demo.cpp	(revision 285)
+++ /vtcross/trunk/src/service_management_layer/sml_demo.cpp	(revision 411)
@@ -1,2 +1,18 @@
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
+
 #include <cstdlib>
 #include <cstring>
Index: /vtcross/trunk/src/service_management_layer/Makefile.am
===================================================================
--- /vtcross/trunk/src/service_management_layer/Makefile.am	(revision 323)
+++ /vtcross/trunk/src/service_management_layer/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/service_management_layer/ServiceManagementLayer.cpp
===================================================================
--- /vtcross/trunk/src/service_management_layer/ServiceManagementLayer.cpp	(revision 316)
+++ /vtcross/trunk/src/service_management_layer/ServiceManagementLayer.cpp	(revision 411)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* Inter-component communication handled by sockets and FD's.  
Index: /vtcross/trunk/src/Makefile.am
===================================================================
--- /vtcross/trunk/src/Makefile.am	(revision 342)
+++ /vtcross/trunk/src/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/COPYING
===================================================================
--- /vtcross/trunk/COPYING	(revision 411)
+++ /vtcross/trunk/COPYING	(revision 411)
@@ -0,0 +1,202 @@
+
+                                 Apache License
+                           Version 2.0, January 2004
+                        http://www.apache.org/licenses/
+
+   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
+
+   1. Definitions.
+
+      "License" shall mean the terms and conditions for use, reproduction,
+      and distribution as defined by Sections 1 through 9 of this document.
+
+      "Licensor" shall mean the copyright owner or entity authorized by
+      the copyright owner that is granting the License.
+
+      "Legal Entity" shall mean the union of the acting entity and all
+      other entities that control, are controlled by, or are under common
+      control with that entity. For the purposes of this definition,
+      "control" means (i) the power, direct or indirect, to cause the
+      direction or management of such entity, whether by contract or
+      otherwise, or (ii) ownership of fifty percent (50%) or more of the
+      outstanding shares, or (iii) beneficial ownership of such entity.
+
+      "You" (or "Your") shall mean an individual or Legal Entity
+      exercising permissions granted by this License.
+
+      "Source" form shall mean the preferred form for making modifications,
+      including but not limited to software source code, documentation
+      source, and configuration files.
+
+      "Object" form shall mean any form resulting from mechanical
+      transformation or translation of a Source form, including but
+      not limited to compiled object code, generated documentation,
+      and conversions to other media types.
+
+      "Work" shall mean the work of authorship, whether in Source or
+      Object form, made available under the License, as indicated by a
+      copyright notice that is included in or attached to the work
+      (an example is provided in the Appendix below).
+
+      "Derivative Works" shall mean any work, whether in Source or Object
+      form, that is based on (or derived from) the Work and for which the
+      editorial revisions, annotations, elaborations, or other modifications
+      represent, as a whole, an original work of authorship. For the purposes
+      of this License, Derivative Works shall not include works that remain
+      separable from, or merely link (or bind by name) to the interfaces of,
+      the Work and Derivative Works thereof.
+
+      "Contribution" shall mean any work of authorship, including
+      the original version of the Work and any modifications or additions
+      to that Work or Derivative Works thereof, that is intentionally
+      submitted to Licensor for inclusion in the Work by the copyright owner
+      or by an individual or Legal Entity authorized to submit on behalf of
+      the copyright owner. For the purposes of this definition, "submitted"
+      means any form of electronic, verbal, or written communication sent
+      to the Licensor or its representatives, including but not limited to
+      communication on electronic mailing lists, source code control systems,
+      and issue tracking systems that are managed by, or on behalf of, the
+      Licensor for the purpose of discussing and improving the Work, but
+      excluding communication that is conspicuously marked or otherwise
+      designated in writing by the copyright owner as "Not a Contribution."
+
+      "Contributor" shall mean Licensor and any individual or Legal Entity
+      on behalf of whom a Contribution has been received by Licensor and
+      subsequently incorporated within the Work.
+
+   2. Grant of Copyright License. Subject to the terms and conditions of
+      this License, each Contributor hereby grants to You a perpetual,
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
+      copyright license to reproduce, prepare Derivative Works of,
+      publicly display, publicly perform, sublicense, and distribute the
+      Work and such Derivative Works in Source or Object form.
+
+   3. Grant of Patent License. Subject to the terms and conditions of
+      this License, each Contributor hereby grants to You a perpetual,
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
+      (except as stated in this section) patent license to make, have made,
+      use, offer to sell, sell, import, and otherwise transfer the Work,
+      where such license applies only to those patent claims licensable
+      by such Contributor that are necessarily infringed by their
+      Contribution(s) alone or by combination of their Contribution(s)
+      with the Work to which such Contribution(s) was submitted. If You
+      institute patent litigation against any entity (including a
+      cross-claim or counterclaim in a lawsuit) alleging that the Work
+      or a Contribution incorporated within the Work constitutes direct
+      or contributory patent infringement, then any patent licenses
+      granted to You under this License for that Work shall terminate
+      as of the date such litigation is filed.
+
+   4. Redistribution. You may reproduce and distribute copies of the
+      Work or Derivative Works thereof in any medium, with or without
+      modifications, and in Source or Object form, provided that You
+      meet the following conditions:
+
+      (a) You must give any other recipients of the Work or
+          Derivative Works a copy of this License; and
+
+      (b) You must cause any modified files to carry prominent notices
+          stating that You changed the files; and
+
+      (c) You must retain, in the Source form of any Derivative Works
+          that You distribute, all copyright, patent, trademark, and
+          attribution notices from the Source form of the Work,
+          excluding those notices that do not pertain to any part of
+          the Derivative Works; and
+
+      (d) If the Work includes a "NOTICE" text file as part of its
+          distribution, then any Derivative Works that You distribute must
+          include a readable copy of the attribution notices contained
+          within such NOTICE file, excluding those notices that do not
+          pertain to any part of the Derivative Works, in at least one
+          of the following places: within a NOTICE text file distributed
+          as part of the Derivative Works; within the Source form or
+          documentation, if provided along with the Derivative Works; or,
+          within a display generated by the Derivative Works, if and
+          wherever such third-party notices normally appear. The contents
+          of the NOTICE file are for informational purposes only and
+          do not modify the License. You may add Your own attribution
+          notices within Derivative Works that You distribute, alongside
+          or as an addendum to the NOTICE text from the Work, provided
+          that such additional attribution notices cannot be construed
+          as modifying the License.
+
+      You may add Your own copyright statement to Your modifications and
+      may provide additional or different license terms and conditions
+      for use, reproduction, or distribution of Your modifications, or
+      for any such Derivative Works as a whole, provided Your use,
+      reproduction, and distribution of the Work otherwise complies with
+      the conditions stated in this License.
+
+   5. Submission of Contributions. Unless You explicitly state otherwise,
+      any Contribution intentionally submitted for inclusion in the Work
+      by You to the Licensor shall be under the terms and conditions of
+      this License, without any additional terms or conditions.
+      Notwithstanding the above, nothing herein shall supersede or modify
+      the terms of any separate license agreement you may have executed
+      with Licensor regarding such Contributions.
+
+   6. Trademarks. This License does not grant permission to use the trade
+      names, trademarks, service marks, or product names of the Licensor,
+      except as required for reasonable and customary use in describing the
+      origin of the Work and reproducing the content of the NOTICE file.
+
+   7. Disclaimer of Warranty. Unless required by applicable law or
+      agreed to in writing, Licensor provides the Work (and each
+      Contributor provides its Contributions) on an "AS IS" BASIS,
+      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+      implied, including, without limitation, any warranties or conditions
+      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
+      PARTICULAR PURPOSE. You are solely responsible for determining the
+      appropriateness of using or redistributing the Work and assume any
+      risks associated with Your exercise of permissions under this License.
+
+   8. Limitation of Liability. In no event and under no legal theory,
+      whether in tort (including negligence), contract, or otherwise,
+      unless required by applicable law (such as deliberate and grossly
+      negligent acts) or agreed to in writing, shall any Contributor be
+      liable to You for damages, including any direct, indirect, special,
+      incidental, or consequential damages of any character arising as a
+      result of this License or out of the use or inability to use the
+      Work (including but not limited to damages for loss of goodwill,
+      work stoppage, computer failure or malfunction, or any and all
+      other commercial damages or losses), even if such Contributor
+      has been advised of the possibility of such damages.
+
+   9. Accepting Warranty or Additional Liability. While redistributing
+      the Work or Derivative Works thereof, You may choose to offer,
+      and charge a fee for, acceptance of support, warranty, indemnity,
+      or other liability obligations and/or rights consistent with this
+      License. However, in accepting such obligations, You may act only
+      on Your own behalf and on Your sole responsibility, not on behalf
+      of any other Contributor, and only if You agree to indemnify,
+      defend, and hold each Contributor harmless for any liability
+      incurred by, or claims asserted against, such Contributor by reason
+      of your accepting any such warranty or additional liability.
+
+   END OF TERMS AND CONDITIONS
+
+   APPENDIX: How to apply the Apache License to your work.
+
+      To apply the Apache License to your work, attach the following
+      boilerplate notice, with the fields enclosed by brackets "[]"
+      replaced with your own identifying information. (Don't include
+      the brackets!)  The text should be enclosed in the appropriate
+      comment syntax for the file format. We also recommend that a
+      file or class name and description of purpose be included on the
+      same "printed page" as the copyright notice for easier
+      identification within third-party archives.
+
+   Copyright [yyyy] [name of copyright owner]
+
+   Licensed under the Apache License, Version 2.0 (the "License");
+   you may not use this file except in compliance with the License.
+   You may obtain a copy of the License at
+
+       http://www.apache.org/licenses/LICENSE-2.0
+
+   Unless required by applicable law or agreed to in writing, software
+   distributed under the License is distributed on an "AS IS" BASIS,
+   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+   See the License for the specific language governing permissions and
+   limitations under the License.
Index: /vtcross/trunk/Makefile.am
===================================================================
--- /vtcross/trunk/Makefile.am	(revision 323)
+++ /vtcross/trunk/Makefile.am	(revision 411)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 ACLOCAL_AMFLAGS = -I m4
 
Index: /vtcross/trunk/reconf
===================================================================
--- /vtcross/trunk/reconf	(revision 323)
+++ /vtcross/trunk/reconf	(revision 411)
@@ -1,3 +1,16 @@
 #!/bin/sh
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
 
 libtoolize && \
